#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>
#include <Array.au3>
#include <Date.au3>

HotKeySet("{UP}","__btn_hunt_plus")
HotKeySet("{DOWN}","__btn_hunt_minus")
HotKeySet("{F9}","__exit")

#Region ### START Koda GUI section ### Form=c:\users\kubiii\pictures\stream\scenes\switch lgp\gui_shiny_hunt.kxf
$Form1_1 = GUICreate("Shiny-Hunter Tool by Kubiii.de", 394, 170)
$Label1 = GUICtrlCreateLabel("Pokmon Let's Go Shiny Hunt", 16, 8, 366, 33)
GUICtrlSetFont(-1, 19, 400, 0, "Lucida Sans")
Global $input_timer = GUICtrlCreateInput("", 16, 72, 121, 25)
Global $input_counter = GUICtrlCreateInput("", 16, 103, 121, 25)
$btn_timer_reset = GUICtrlCreateButton("Reset", 302, 72, 75, 25, $WS_GROUP)
$btn_timer_play = GUICtrlCreateButton("Play", 142, 72, 75, 25, $WS_GROUP)
$btn_timer_pause = GUICtrlCreateButton("Pause", 222, 72, 75, 25, $WS_GROUP)
$btn_hunt_set = GUICtrlCreateButton("Set", 142, 103, 75, 25, $WS_GROUP)
$btn_hunt_plus = GUICtrlCreateButton("+", 222, 103, 75, 25, $WS_GROUP)
$btn_hunt_minus = GUICtrlCreateButton("-", 302, 103, 75, 25, $WS_GROUP)
$Label2 = GUICtrlCreateLabel("by Kubiii.de", 320, 48, 58, 17)
Global $input_pokemon = GUICtrlCreateInput("", 158, 136, 121, 25)
$Label3 = GUICtrlCreateLabel("Pokmon:", 75, 138, 75, 24)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$btn_pkm_set = GUICtrlCreateButton("Set Pkm", 302, 136, 75, 25, $WS_GROUP)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

;~ MERKER Dratini: 85 | 01:23:03

;~ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~
;~ ######## ##      ## #### ########  ######  ##     ##     ######## ##     ##       ## ##    ## ##     ## ########  #### ########  #######     ##
;~    ##    ##  ##  ##  ##     ##    ##    ## ##     ##        ##    ##     ##      ##  ##   ##  ##     ## ##     ##  ##  ##       ##     ##  ####
;~    ##    ##  ##  ##  ##     ##    ##       ##     ##        ##    ##     ##     ##   ##  ##   ##     ## ##     ##  ##  ##       ##     ##    ##
;~    ##    ##  ##  ##  ##     ##    ##       #########        ##    ##     ##    ##    #####    ##     ## ########   ##  #######   #######     ##
;~    ##    ##  ##  ##  ##     ##    ##       ##     ##        ##     ##   ##    ##     ##  ##   ##     ## ##     ##  ##        ## ##     ##    ##
;~    ##    ##  ##  ##  ##     ##    ##    ## ##     ## ###    ##      ## ##    ##      ##   ##  ##     ## ##     ##  ##  ##    ## ##     ##    ##
;~    ##     ###  ###  ####    ##     ######  ##     ## ###    ##       ###    ##       ##    ##  #######  ########  ####  ######   #######   ######
;~
;~ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;~ Variablendefinition
$str_timer = ""
$str_pkm = ""
$str_counter = ""

$index_cfg_pkm = ""
$index_cfg_timer = ""

$file_config = @ScriptDir & "\shiny_hunt.cfg"
$path_cfg_timer = ""
$path_cfg_pkm = ""


;~ MsgBox(0,"",@ScriptDir & "\shiny_hunt.cfg")

;~ Dateipfade aus Datei auslesen
If FileExists($file_config) Then

	$h_file_config = FileOpen($file_config)

	;~ 	Falls Fehler beim ffnen der Datei auftritt - ERROR
	If $h_file_config = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Config Datei")
		Exit
	EndIf

	$arr_cfg_file			= FileReadToArray($h_file_config)

	FileClose($h_file_config)


	;~ Durchlaufen der vorhanden CFG Datei, um zu ermitteln, welchen Indexwert der entsprechende Paramete besitzt
	For $i = 0 To UBound($arr_cfg_file)-1 Step 1


		;~ 	Durchsuche Array nach Pfadstring fr Timer CFG
		If StringRegExp($arr_cfg_file[$i],"path_file_timer*") Then
			$index_cfg_timer = $i
		EndIf

		If StringRegExp($arr_cfg_file[$i],"path_file_pkm*") Then
			$index_cfg_pkm = $i
		EndIf

	Next

	;~ Aufteilen der Config-Zeilen am Trennzeichen "="
	$arr_cfg_timer 	= StringSplit($arr_cfg_file[$index_cfg_timer],"=")
	$arr_cfg_pkm 	= StringSplit($arr_cfg_file[$index_cfg_pkm],"=")


	;~ Pfad je Art aus CFG auslesen
	$path_cfg_timer	= $arr_cfg_timer[2]
	$path_cfg_pkm	= $arr_cfg_pkm[2]

	;~ Auslesen der Timer Datei
	If FileExists($path_cfg_timer) Then

		$h_file_timer = FileOpen($path_cfg_timer)

		If $h_file_timer = -1 Then
			MsgBox(0,"","Fehler beim ffnen der Timer Datei" & @CRLF & @CRLF & $path_cfg_timer)
			Exit
		EndIf


		$str_timer = FileRead($h_file_timer)

		FileClose($h_file_timer)

	Else

		__createFile($path_cfg_timer,"00:00:00")

	EndIf


	;~ Auslesen der Pkm Datei
	If FileExists($path_cfg_pkm) Then

		$h_file_pkm = FileOpen($path_cfg_pkm)

		If $h_file_pkm = -1 Then
			MsgBox(0,"","Fehler beim ffnen der Pkm Datei" & @CRLF & @CRLF & $path_cfg_pkm)
			Exit
		EndIf

		$str_pkm = FileRead($h_file_pkm)

		FileClose($h_file_pkm)

	Else

		__createFile($path_cfg_pkm,"[Pokemon] : 0")

	EndIf

Else

	_FileCreate($file_config)

;~ 	ffnen im Modus: WRITE (1)
	$h_file_config = FileOpen($file_config,2)

;~ 	Falls Fehler beim ffnen der Datei auftritt - ERROR
	If $h_file_config = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Config Datei")
		Exit
	EndIf

	FileWriteLine($h_file_config,"path_file_timer=" & @ScriptDir & "\timer.txt")
	FileWriteLine($h_file_config,"path_file_pkm=" & @ScriptDir & "\pkm_counter.txt")

	__createFile(@ScriptDir & "\timer.txt","00:00:00")
	__createFile(@ScriptDir & "\pkm_counter.txt","[Pokemon] : 0")

	MsgBox(0,"Erstkonfiguration abgeschlossen!","Bitte starte das Programm erneut." & @CRLF & @CRLF& "Deine Konfigurationsdateien wurden angelegt unter: " & @CRLF & @CRLF & @ScriptDir)
	Exit

EndIf



If FileExists($path_cfg_timer) Then

	$h_file_timer = FileOpen($path_cfg_timer)

	If $h_file_timer = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Timer Datei")
		Exit
	EndIf

;~ 	Auslesen der Timer Datei (aktueller Timer Wert)
	$str_timer = FileReadLine($h_file_timer)

	FileClose($h_file_timer)

Else

	__createFile($path_cfg_timer,"00:00:00")

	$str_timer = "00:00:00"

EndIf



If FileExists($path_cfg_pkm) Then

	$h_file_pkm = FileOpen($path_cfg_pkm)

	If $h_file_pkm = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Pkm Counter Datei")

	EndIf

;~ 	Auslesen der Pkm Datei (aktueller Pkm & Counter Wert)
	$str_pkm = FileReadLine($h_file_pkm)

	$arr_line = StringSplit($str_pkm,":")
	$str_line_pkm = StringReplace($arr_line[1]," ","")
	$str_line_cnt = StringReplace($arr_line[2]," ","")

	FileClose($h_file_pkm)

Else

	__createFile($path_cfg_pkm,"[Pokemon] : 0")

	$str_pkm = "[Pokemon] : 0"

EndIf


;~ GUI Inputfelder befllen mit Werten aus Config-Dateien
GUICtrlSetData($input_timer,$str_timer)
GUICtrlSetData($input_counter,$str_line_cnt)
GUICtrlSetData($input_pokemon,$str_line_pkm)



;~ Main

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
;~ 		Exit-Button (obere Ecke)
		Case $GUI_EVENT_CLOSE
			Exit

;~ 		Namen fr das Pokemon festsetzen
		Case $btn_pkm_set
			__btn_pkm_set("pkm")

		Case $btn_hunt_set
			__btn_pkm_set("hunt")

		Case $btn_hunt_plus
			__btn_hunt_plus()

		Case $btn_hunt_minus
			__btn_hunt_minus()

		Case $btn_timer_reset
			__btn_timer_reset()

		Case $btn_timer_play
			AdlibRegister("__btn_timer_play",1000)

		Case $btn_timer_pause
			__stop_timer()



	EndSwitch
WEnd




;~ SECTION: FUNCTIONS

Func __exit()
	Exit
EndFunc


Func __createFile($path,$content)

	_FileCreate($path)

	$handle_file = FileOpen($path,2)

	If $handle_file = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Datei: " & @CRLF & @CRLF & $path)
		Exit
	EndIf

;~ 	MsgBox(0,"",$path)
;~ 	MsgBox(0,"",$content)

	FileWriteLine($handle_file,$content)

	FileClose($handle_file)

EndFunc

Func __modifyFile($path,$content)

;~ 	MsgBox(0,"",$path & " | " & $content)

	Local $handle_file = FileOpen($path,2)

	If $handle_file = -1 Then
		MsgBox(0,"","Fehler beim ffnen der Datei: " & @CRLF & @CRLF & $path)
		Exit
	EndIf

	FileWriteLine($handle_file,$content)

	FileClose($handle_file)

EndFunc


Func __btn_pkm_set($mode)
	Local $input_pkm 		= GUICtrlRead($input_pokemon)
	Local $input_cnt		= GUICtrlRead($input_counter)

	If $input_cnt <= 0 Then
;~ 		MsgBox(0,"Fehler (Zahl kleiner als 0)","Bitte eine Zahl grer/gleich 0 eingeben!")
		$input_cnt = 0
	EndIf

	GUICtrlSetData($input_counter,$input_cnt)

	Local $content = $input_pkm & ": " & $input_cnt

	__modifyFile($path_cfg_pkm,$content)

	If $mode = "pkm" Then
		MsgBox(0,"Pokmon wurde aktualisiert!","Pokmon wurde gendert")
	ElseIf $mode = "hunt" Then
		MsgBox(0,"Counter wurde manuell gendert!","Counter wurde gendert!")
	EndIf


EndFunc

Func __btn_hunt_plus()

	Local $input_cnt		= GUICtrlRead($input_counter)
	Local $input_pkm 		= GUICtrlRead($input_pokemon)

	$i = $input_cnt + 1

	If $input_cnt < 0 Then
		MsgBox(0,"Fehler (Zahl kleiner als 0)","Bitte eine Zahl grer/gleich 0 eingeben!")
		$i = 0
	EndIf

	$content = $input_pkm & ": " & $i
	GUICtrlSetData($input_counter,$i)

	__modifyFile($path_cfg_pkm,$content)

EndFunc

Func __btn_hunt_minus()

	Local $input_cnt		= GUICtrlRead($input_counter)
	Local $input_pkm 		= GUICtrlRead($input_pokemon)

	$i = $input_cnt - 1

	If $input_cnt <= 0 Then
		MsgBox(0,"Fehler (Zahl kleiner als 0)","Bitte eine Zahl grer/gleich 0 eingeben!")
		$i = 0
	EndIf

	$content = $input_pkm & ": " & $i
	GUICtrlSetData($input_counter,$i)

	__modifyFile($path_cfg_pkm,$content)

EndFunc

Func __btn_timer_reset()

	__stop_timer()

	__modifyFile($path_cfg_timer,"00:00:00")
	GUICtrlSetData($input_timer,FileReadLine($path_cfg_timer))

EndFunc

Func __btn_timer_play()

	$str_timer = FileReadLine($path_cfg_timer)

	$seconds = __convertTimeToSec($str_timer)

	$tmp_new_seconds = $seconds + 1

	$str_to_file = __convertSecToTime($tmp_new_seconds)

	__modifyFile($path_cfg_timer,$str_to_file)
	GUICtrlSetData($input_timer,$str_to_file)



EndFunc

Func __convertTimeToSec($str_time)

	$arr_file_timer = StringSplit($str_time,":")

	Local $return_value = $arr_file_timer[1] * 3600 + $arr_file_timer[2] * 60 + $arr_file_timer[3]

	Return $return_value

EndFunc


Func __convertSecToTime($sec)

	$hour 		= "00"
	$min  		= "00"
	$rest_sec 	= "00"

	If Mod($sec,3600) <> $sec Then

		$rest_stunde = Mod($sec,3600) ; Rest der Zahl bei 7205 zB: 5
		$hour = ($sec - $rest_stunde) / 3600
	;~ 	MsgBox(0,"","Stunde: " &$hour)
	Else
		$rest_stunde = $sec
	EndIf

	If Mod($rest_stunde,60) <> $sec Then

		$rest_minute = Mod($rest_stunde,60)
		$min = ($rest_stunde - $rest_minute) / 60
	;~ 	MsgBox(0,"","Minute :" & $min)
	Else

		$rest_minute = $sec

	EndIf

	$rest_sec = $rest_minute
	;~ MsgBox(0,"","Sekunden: " & $rest_sec)

	;~ Lnge der Strings auf 2 erhhen fr bessere Anzeige
	If StringLen($hour) = 1 Then
		$ret_hour = "0" & $hour
	Else
		$ret_hour = $hour
	EndIf

	If StringLen($min) = 1 Then
		$ret_min = "0" & $min
	Else
		$ret_min = $min
	EndIf

	If StringLen($rest_sec) = 1 Then
		$ret_sec = "0" & $rest_sec
	Else
		$ret_sec = $rest_sec
	EndIf

	Local $return_value = $ret_hour & ":" & $ret_min & ":" & $ret_sec

;~ 	MsgBox(0,"",$return_value)

	Return $return_value

EndFunc


Func __stop_timer()

	AdlibUnRegister("__btn_timer_play")

EndFunc